package com.nisum.kafka_poc.practice;

import java.util.concurrent.BrokenBarrierException;
import java.util.concurrent.CyclicBarrier;

public class CyclicBarrierExample implements Runnable{

    private final int id;
    private final CyclicBarrier cyclicBarrier;

    public CyclicBarrierExample(int id, CyclicBarrier cyclicBarrier) {
        this.id = id;
        this.cyclicBarrier = cyclicBarrier;
    }


    @Override
    public void run() {

        try {
            System.out.println("Thread " + id + " is ready...");
            cyclicBarrier.await(); // Wait for all threads to reach this point
            System.out.println("Thread " + id + " is running at " + System.currentTimeMillis());
        } catch (InterruptedException | BrokenBarrierException e) {
            Thread.currentThread().interrupt();
        }
    }
}
