/*
package com.nisum.kafka_poc;

import com.nisum.kafka_poc.service.KafkaConsumerService;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;
import org.mockito.InjectMocks;
import org.mockito.Mock;
import org.mockito.Mockito;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.kafka.core.KafkaTemplate;
import org.springframework.kafka.test.context.EmbeddedKafka;
import org.springframework.test.annotation.DirtiesContext;
import org.springframework.test.context.bean.override.mockito.MockitoBean;

import java.util.concurrent.CountDownLatch;
import java.util.concurrent.TimeUnit;

import static org.awaitility.Awaitility.await;


@SpringBootTest
@EmbeddedKafka(partitions = 1, topics = "test", brokerProperties = {"listeners=PLAINTEXT://localhost:9092", "port=9092"})
@DirtiesContext(classMode = DirtiesContext.ClassMode.AFTER_CLASS)
class KafkaPocApplicationTests1 {

	@MockitoBean
	private KafkaConsumerService kafkaConsumerService;

	@Mock
	private KafkaTemplate<String, String> kafkaTemplate;



	@Test
	void testKafkaListenerReceivesMessage() throws InterruptedException {
		kafkaTemplate.send("test", "Hello, Kafka!");

		// Wait for the message to be consumed
		await().atMost(5, TimeUnit.SECONDS).untilAsserted(() ->
				Mockito.verify(kafkaConsumerService, Mockito.timeout(5000)).listen("Hello, Kafka!")

		);
	}

}
*/
