package practice;

import com.nisum.kafka_poc.practice.DistinctValues;
import org.junit.jupiter.api.Test;

import java.util.Arrays;
import java.util.List;

import static org.junit.jupiter.api.Assertions.assertEquals;

public class DistictValuesTest {

    @Test
    void testGetSortedDistinctValues() {
        List<Integer> input = Arrays.asList(1, 2, 3, 4, 5, 2, 6, 3, 7, 8, 8, 9);
        List<Integer> expectedOutput = Arrays.asList(9, 8, 7, 6, 5, 4, 3, 2, 1);

        List<Integer> actualOutput = DistinctValues.getSortedDistinctValues(input);

        assertEquals(expectedOutput, actualOutput);
    }

    @Test
    void testGetSortedDistinctValues_AllSameValues() {
        List<Integer> input = Arrays.asList(5, 5, 5, 5, 5);
        List<Integer> expectedOutput = Arrays.asList(5); // Only one distinct value

        List<Integer> actualOutput = DistinctValues.getSortedDistinctValues(input);

        assertEquals(expectedOutput, actualOutput);
    }
}
