package practice;

import com.nisum.kafka_poc.practice.FindDuplicate;
import org.junit.jupiter.api.Test;

import java.util.Arrays;
import java.util.List;

import static org.junit.jupiter.api.Assertions.assertEquals;

public class FindDuplicatesTest {
    @Test
    void testFindDuplicates() {
        List<Integer> input = Arrays.asList(1, 2, 3, 4, 5, 2, 6, 3, 7, 8, 8, 9);
        List<Integer> expectedDuplicates = Arrays.asList(2, 3, 8);

        List<Integer> actualDuplicates = FindDuplicate.findDuplicates(input);

        assertEquals(expectedDuplicates, actualDuplicates);
    }

    @Test
    void testFindDuplicates_NoDuplicates() {
        List<Integer> input = Arrays.asList(1, 2, 3, 4, 5, 6, 7, 8, 9);
        List<Integer> expectedDuplicates = Arrays.asList();

        List<Integer> actualDuplicates = FindDuplicate.findDuplicates(input);

        assertEquals(expectedDuplicates, actualDuplicates);
    }

    @Test
    void testFindDuplicates_AllDuplicates() {
        List<Integer> input = Arrays.asList(1, 1, 2, 2, 3, 3);
        List<Integer> expectedDuplicates = Arrays.asList(1, 2, 3);

        List<Integer> actualDuplicates = FindDuplicate.findDuplicates(input);

        assertEquals(expectedDuplicates, actualDuplicates);
    }
}
