package practice;

import com.nisum.kafka_poc.practice.ListToMap;
import org.junit.jupiter.api.Test;
import reactor.core.publisher.Mono;
import reactor.test.StepVerifier;
import reactor.util.function.Tuple2;

public class ListToMapTest {

    @Test
    void testCombineMonos_Success() {
        Mono<String> mono1 = Mono.just("Hello");
        Mono<String> mono2 = Mono.just("World");

        Mono<Tuple2<String, String>> result = ListToMap.combineMonos(mono1, mono2);

        StepVerifier.create(result)
                .expectNextMatches(tuple -> tuple.getT1().equals("Hello") && tuple.getT2().equals("World"))
                .verifyComplete();
    }

    @Test
    void testCombineMonos_ErrorScenario() {
        Mono<String> mono1 = Mono.just("Hello");
        Mono<String> mono2 = Mono.error(new RuntimeException("Something went wrong"));

        Mono<Tuple2<String, String>> result = ListToMap.combineMonos(mono1, mono2);

        StepVerifier.create(result)
                .expectErrorMessage("Something went wrong")
                .verify();
    }
}
