package practice;

import com.nisum.kafka_poc.practice.NonRepeatedCharacters;
import org.junit.jupiter.api.Test;

import java.util.Optional;

import static org.junit.jupiter.api.Assertions.assertEquals;
import static org.junit.jupiter.api.Assertions.assertTrue;

public class NonrepeatedCharactersTest {

    @Test
    void testFindFirstNonRepeatedChar_Success() {
        String input = "Come here";
        Optional<Character> result = NonRepeatedCharacters.findFirstNonRepeatedChar(input);

        assertTrue(result.isPresent());
        assertEquals('C', result.get());
    }

    @Test
    void testFindFirstNonRepeatedChar_NoUniqueChar() {
        String input = "aabbcc";
        Optional<Character> result = NonRepeatedCharacters.findFirstNonRepeatedChar(input);

        assertTrue(result.isEmpty()); // No non-repeating characters
    }

    @Test
    void testFindFirstNonRepeatedChar_OnlyOneCharacter() {
        String input = "x";
        Optional<Character> result = NonRepeatedCharacters.findFirstNonRepeatedChar(input);

        assertTrue(result.isPresent());
        assertEquals('x', result.get());
    }


    @Test
    void testFindFirstNonRepeatedChar_EmptyString() {
        String input = "";
        Optional<Character> result = NonRepeatedCharacters.findFirstNonRepeatedChar(input);

        assertTrue(result.isEmpty()); // No characters to check
    }
}

