package practice;

import com.nisum.kafka_poc.practice.StartsWithOne;
import org.junit.jupiter.api.Test;

import java.util.Arrays;
import java.util.List;

import static org.junit.jupiter.api.Assertions.assertEquals;
import static org.junit.jupiter.api.Assertions.assertTrue;

public class StartsWithOneTest {

    @Test
    void testFilterNumbersStartingWithOne() {
        List<Integer> numbers = Arrays.asList(1, 2, 13, 4, 15, 2, 16, 3, 7, 8, 8, 9);
        List<Integer> expected = Arrays.asList(1, 13, 15, 16); // Expected numbers starting with '1'

        assertEquals(expected, StartsWithOne.filterNumbersStartingWithOne(numbers));
    }

    @Test
    void testNoNumbersStartingWithOne() {
        List<Integer> numbers = Arrays.asList(2, 3, 4, 5, 6, 7, 8, 9);
        assertTrue(StartsWithOne.filterNumbersStartingWithOne(numbers).isEmpty());
    }

    @Test
    void testAllNumbersStartWithOne() {
        List<Integer> numbers = Arrays.asList(10, 11, 12, 13, 14, 15);
        assertEquals(numbers, StartsWithOne.filterNumbersStartingWithOne(numbers));
    }

    @Test
    void testEmptyList() {
        assertTrue(StartsWithOne.filterNumbersStartingWithOne(Arrays.asList()).isEmpty());
    }
}
